diff --git a/common/Kconfig b/common/Kconfig
index a94c7b9..aae754b 100644
--- a/common/Kconfig
+++ b/common/Kconfig
@@ -103,9 +103,9 @@ config BOOTDELAY
 	depends on AUTOBOOT
 	help
 	  Delay before automatically running bootcmd;
+	  set to 0 to autoboot with no delay, but you can stop it by key input.
 	  set to -1 to disable autoboot.
 	  set to -2 to autoboot with no delay and not check for abort
-	  (even when CONFIG_ZERO_BOOTDELAY_CHECK is defined).
 
 	  See doc/README.autoboot for details.
 
diff --git a/common/autoboot.c b/common/autoboot.c
index 223e062..35deece 100644
--- a/common/autoboot.c
+++ b/common/autoboot.c
@@ -187,10 +187,8 @@ static int abortboot_keyed(int bootdelay)
 	int abort;
 	uint64_t etime = endtick(bootdelay);
 
-#ifndef CONFIG_ZERO_BOOTDELAY_CHECK
-	if (bootdelay == 0)
+	if (bootdelay < 0)
 		return 0;
-#endif
 
 #  ifdef CONFIG_AUTOBOOT_PROMPT
 	/*
@@ -230,7 +228,6 @@ static int abortboot_normal(int bootdelay)
 		printf("Hit any key to stop autoboot: %2d ", bootdelay);
 #endif
 
-#if defined CONFIG_ZERO_BOOTDELAY_CHECK
 	/*
 	 * Check if key already pressed
 	 * Don't check if bootdelay < 0
@@ -242,7 +239,6 @@ static int abortboot_normal(int bootdelay)
 			abort = 1;	/* don't auto boot	*/
 		}
 	}
-#endif
 
 	while ((bootdelay > 0) && (!abort)) {
 		--bootdelay;
diff --git a/configs/cairo_defconfig b/configs/cairo_defconfig
index 5257312..c529c7c 100644
--- a/configs/cairo_defconfig
+++ b/configs/cairo_defconfig
@@ -2,7 +2,7 @@ CONFIG_ARM=y
 CONFIG_OMAP34XX=y
 CONFIG_TARGET_OMAP3_CAIRO=y
 CONFIG_SPL=y
-CONFIG_BOOTDELAY=0
+CONFIG_BOOTDELAY=-2
 CONFIG_HUSH_PARSER=y
 CONFIG_SYS_PROMPT="Cairo # "
 CONFIG_CMD_BOOTZ=y
diff --git a/configs/controlcenterd_TRAILBLAZER_DEVELOP_defconfig b/configs/controlcenterd_TRAILBLAZER_DEVELOP_defconfig
index b6f14db..efb8ad6 100644
--- a/configs/controlcenterd_TRAILBLAZER_DEVELOP_defconfig
+++ b/configs/controlcenterd_TRAILBLAZER_DEVELOP_defconfig
@@ -2,7 +2,7 @@ CONFIG_PPC=y
 CONFIG_MPC85xx=y
 CONFIG_TARGET_CONTROLCENTERD=y
 CONFIG_SYS_EXTRA_OPTIONS="TRAILBLAZER,SPIFLASH,DEVELOP"
-CONFIG_BOOTDELAY=0
+CONFIG_BOOTDELAY=-2
 # CONFIG_CMD_BOOTM is not set
 # CONFIG_CMD_IMLS is not set
 # CONFIG_CMD_FLASH is not set
diff --git a/configs/controlcenterd_TRAILBLAZER_defconfig b/configs/controlcenterd_TRAILBLAZER_defconfig
index 2c45aff..45e8b8f 100644
--- a/configs/controlcenterd_TRAILBLAZER_defconfig
+++ b/configs/controlcenterd_TRAILBLAZER_defconfig
@@ -2,7 +2,7 @@ CONFIG_PPC=y
 CONFIG_MPC85xx=y
 CONFIG_TARGET_CONTROLCENTERD=y
 CONFIG_SYS_EXTRA_OPTIONS="TRAILBLAZER,SPIFLASH"
-CONFIG_BOOTDELAY=0
+CONFIG_BOOTDELAY=-2
 # CONFIG_CMD_BOOTM is not set
 # CONFIG_CMD_IMLS is not set
 # CONFIG_CMD_FLASH is not set
diff --git a/configs/kwb_defconfig b/configs/kwb_defconfig
index 790292e..5d97446 100644
--- a/configs/kwb_defconfig
+++ b/configs/kwb_defconfig
@@ -2,7 +2,7 @@ CONFIG_ARM=y
 CONFIG_TARGET_KWB=y
 CONFIG_SPL=y
 CONFIG_SYS_EXTRA_OPTIONS="SERIAL1,CONS_INDEX=1"
-CONFIG_BOOTDELAY=0
+CONFIG_BOOTDELAY=-2
 CONFIG_HUSH_PARSER=y
 # CONFIG_CMD_BOOTD is not set
 # CONFIG_CMD_BOOTM is not set
diff --git a/configs/omap3_evm_quick_mmc_defconfig b/configs/omap3_evm_quick_mmc_defconfig
index 801c959..ebdc105 100644
--- a/configs/omap3_evm_quick_mmc_defconfig
+++ b/configs/omap3_evm_quick_mmc_defconfig
@@ -2,7 +2,7 @@ CONFIG_ARM=y
 CONFIG_OMAP34XX=y
 CONFIG_TARGET_OMAP3_EVM_QUICK_MMC=y
 CONFIG_SPL=y
-CONFIG_BOOTDELAY=0
+CONFIG_BOOTDELAY=-2
 CONFIG_SYS_PROMPT="OMAP3_EVM # "
 # CONFIG_CMD_BDI is not set
 # CONFIG_CMD_CONSOLE is not set
diff --git a/configs/omap3_evm_quick_nand_defconfig b/configs/omap3_evm_quick_nand_defconfig
index 8815fca..52b08b8 100644
--- a/configs/omap3_evm_quick_nand_defconfig
+++ b/configs/omap3_evm_quick_nand_defconfig
@@ -2,7 +2,7 @@ CONFIG_ARM=y
 CONFIG_OMAP34XX=y
 CONFIG_TARGET_OMAP3_EVM_QUICK_NAND=y
 CONFIG_SPL=y
-CONFIG_BOOTDELAY=0
+CONFIG_BOOTDELAY=-2
 CONFIG_SYS_PROMPT="OMAP3_EVM # "
 # CONFIG_CMD_BDI is not set
 # CONFIG_CMD_CONSOLE is not set
diff --git a/configs/tseries_mmc_defconfig b/configs/tseries_mmc_defconfig
index 337404b..92eb2b7 100644
--- a/configs/tseries_mmc_defconfig
+++ b/configs/tseries_mmc_defconfig
@@ -3,7 +3,7 @@ CONFIG_TARGET_TSERIES=y
 CONFIG_SPL=y
 CONFIG_OF_BOARD_SETUP=y
 CONFIG_SYS_EXTRA_OPTIONS="SERIAL1,CONS_INDEX=1,EMMC_BOOT"
-CONFIG_BOOTDELAY=0
+CONFIG_BOOTDELAY=-2
 CONFIG_HUSH_PARSER=y
 CONFIG_CMD_BOOTZ=y
 # CONFIG_CMD_IMI is not set
diff --git a/configs/tseries_nand_defconfig b/configs/tseries_nand_defconfig
index 4dc0296..8b5ae6e 100644
--- a/configs/tseries_nand_defconfig
+++ b/configs/tseries_nand_defconfig
@@ -3,7 +3,7 @@ CONFIG_TARGET_TSERIES=y
 CONFIG_SPL=y
 CONFIG_OF_BOARD_SETUP=y
 CONFIG_SYS_EXTRA_OPTIONS="SERIAL1,CONS_INDEX=1,NAND"
-CONFIG_BOOTDELAY=0
+CONFIG_BOOTDELAY=-2
 CONFIG_HUSH_PARSER=y
 CONFIG_CMD_BOOTZ=y
 # CONFIG_CMD_IMI is not set
diff --git a/configs/tseries_spi_defconfig b/configs/tseries_spi_defconfig
index 5b52bf6..646e3c8 100644
--- a/configs/tseries_spi_defconfig
+++ b/configs/tseries_spi_defconfig
@@ -3,7 +3,7 @@ CONFIG_TARGET_TSERIES=y
 CONFIG_SPL=y
 CONFIG_OF_BOARD_SETUP=y
 CONFIG_SYS_EXTRA_OPTIONS="SERIAL1,CONS_INDEX=1,SPI_BOOT,EMMC_BOOT"
-CONFIG_BOOTDELAY=0
+CONFIG_BOOTDELAY=-2
 CONFIG_HUSH_PARSER=y
 CONFIG_CMD_BOOTZ=y
 # CONFIG_CMD_IMI is not set
diff --git a/doc/README.autoboot b/doc/README.autoboot
index 227e3b5..30fd0b0 100644
--- a/doc/README.autoboot
+++ b/doc/README.autoboot
@@ -132,14 +132,6 @@ What they do
 	provides an escape sequence from the limited "password"
 	strings.
 
-
-  CONFIG_ZERO_BOOTDELAY_CHECK
-
-	If this option is defined, you can stop the autoboot process
-	by hitting a key even in that case when "bootdelay" has been
-	set to 0. You can set "bootdelay" to a negative value to
-	prevent the check for console input.
-
   CONFIG_RESET_TO_RETRY
 
 	(Only effective when CONFIG_BOOT_RETRY_TIME is also set)
diff --git a/include/configs/CPCI2DP.h b/include/configs/CPCI2DP.h
index c5c3a84..fb30c70 100644
--- a/include/configs/CPCI2DP.h
+++ b/include/configs/CPCI2DP.h
@@ -98,7 +98,6 @@
 #define CONFIG_SYS_LOAD_ADDR	0x100000	/* default load address */
 #define CONFIG_SYS_EXTBDINFO	1		/* To use extended board_into (bd_t) */
 
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
 
 #define CONFIG_VERSION_VARIABLE 1	/* include version env variable */
 
diff --git a/include/configs/CPCI4052.h b/include/configs/CPCI4052.h
index db953b9..e5d4b0c 100644
--- a/include/configs/CPCI4052.h
+++ b/include/configs/CPCI4052.h
@@ -121,7 +121,6 @@
 
 #define CONFIG_CMDLINE_EDITING		/* add command line history	*/
 
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
 
 #define CONFIG_VERSION_VARIABLE 1	/* include version env variable */
 
diff --git a/include/configs/MIP405.h b/include/configs/MIP405.h
index 79027e2..6ef39db 100644
--- a/include/configs/MIP405.h
+++ b/include/configs/MIP405.h
@@ -99,7 +99,6 @@
 #define CONFIG_BAUDRATE		9600	/* STD Baudrate */
 /* autoboot (do NOT change this set environment variable "bootdelay" to -1 instead) */
 /* #define CONFIG_BOOT_RETRY_TIME	-10	/XXX* feature is available but not enabled */
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check console even if bootdelay = 0 */
 
 #define CONFIG_BOOTCOMMAND	"diskboot 400000 0:1; bootm" /* autoboot command		*/
 #define CONFIG_BOOTARGS		"console=ttyS0,9600 root=/dev/hda5" /* boot arguments */
diff --git a/include/configs/PIP405.h b/include/configs/PIP405.h
index e7c7a99..9203f85 100644
--- a/include/configs/PIP405.h
+++ b/include/configs/PIP405.h
@@ -91,7 +91,6 @@
 
 /* autoboot (do NOT change this set environment variable "bootdelay" to -1 instead) */
 /* #define CONFIG_BOOT_RETRY_TIME	-10	/XXX* feature is available but not enabled */
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check console even if bootdelay = 0 */
 
 #define CONFIG_BOOTCOMMAND	"diskboot 400000 0:1; bootm" /* autoboot command		*/
 #define CONFIG_BOOTARGS		"console=ttyS0,9600 root=/dev/hda5" /* boot arguments */
diff --git a/include/configs/PLU405.h b/include/configs/PLU405.h
index 558f3e2..c2e067a 100644
--- a/include/configs/PLU405.h
+++ b/include/configs/PLU405.h
@@ -117,7 +117,6 @@
 #define CONFIG_SYS_EXTBDINFO	1		/* To use extended board_into (bd_t) */
 
 #define CONFIG_CMDLINE_EDITING	1	/* add command line history	*/
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
 
 #define CONFIG_VERSION_VARIABLE 1	/* include version env variable */
 
diff --git a/include/configs/PMC405DE.h b/include/configs/PMC405DE.h
index 5f17d76..619222f 100644
--- a/include/configs/PMC405DE.h
+++ b/include/configs/PMC405DE.h
@@ -92,7 +92,6 @@
 
 #define CONFIG_CMDLINE_EDITING	1	/* add command line history     */
 #define CONFIG_MX_CYCLIC	1	/* enable mdc/mwc commands      */
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
 #define CONFIG_VERSION_VARIABLE 1	/* include version env variable */
 
 /*
diff --git a/include/configs/PMC440.h b/include/configs/PMC440.h
index 868ca84..d3183ff 100644
--- a/include/configs/PMC440.h
+++ b/include/configs/PMC440.h
@@ -312,7 +312,6 @@
 
 #define CONFIG_CMDLINE_EDITING	1	/* add command line history     */
 #define CONFIG_MX_CYCLIC	1	/* enable mdc/mwc commands      */
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
 #define CONFIG_VERSION_VARIABLE 1	/* include version env variable */
 
 /*-----------------------------------------------------------------------
diff --git a/include/configs/VCMA9.h b/include/configs/VCMA9.h
index 968e1df..a60c7c1 100644
--- a/include/configs/VCMA9.h
+++ b/include/configs/VCMA9.h
@@ -117,7 +117,6 @@
 
 #define CONFIG_BOOT_RETRY_TIME		-1
 #define CONFIG_RESET_TO_RETRY
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_NETMASK			255.255.255.0
 #define CONFIG_IPADDR			10.0.0.110
diff --git a/include/configs/VOM405.h b/include/configs/VOM405.h
index dde98f6..e87cea8 100644
--- a/include/configs/VOM405.h
+++ b/include/configs/VOM405.h
@@ -105,7 +105,6 @@
 #define CONFIG_SYS_EXTBDINFO	1		/* To use extended board_into (bd_t) */
 
 #define CONFIG_CMDLINE_EDITING	1	/* add command line history	*/
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
 
 #define CONFIG_VERSION_VARIABLE 1	/* include version env variable */
 
diff --git a/include/configs/a3m071.h b/include/configs/a3m071.h
index 7ec404d..8f17dd1 100644
--- a/include/configs/a3m071.h
+++ b/include/configs/a3m071.h
@@ -322,7 +322,6 @@
  */
 
 #undef  CONFIG_BOOTARGS
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_SYS_AUTOLOAD	"n"
 
diff --git a/include/configs/amcc-common.h b/include/configs/amcc-common.h
index 2666ca6..9bda7fa 100644
--- a/include/configs/amcc-common.h
+++ b/include/configs/amcc-common.h
@@ -78,7 +78,6 @@
 #define CONFIG_CMDLINE_EDITING		/* add command line history	*/
 #define CONFIG_AUTO_COMPLETE		/* add autocompletion support	*/
 #define CONFIG_MX_CYCLIC		/* enable mdc/mwc commands      */
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
 #define CONFIG_VERSION_VARIABLE 	/* include version env variable */
 #define CONFIG_SYS_CONSOLE_INFO_QUIET	/* don't print console @ startup*/
 
diff --git a/include/configs/apf27.h b/include/configs/apf27.h
index f44f71c..51a16eb 100644
--- a/include/configs/apf27.h
+++ b/include/configs/apf27.h
@@ -148,7 +148,6 @@
 #define CONFIG_SETUP_MEMORY_TAGS	/* send memory definition to kernel */
 #define CONFIG_INITRD_TAG		/* send initrd params	*/
 
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 #define	CONFIG_BOOTFILE		__stringify(CONFIG_BOARD_NAME) "-linux.bin"
 #define CONFIG_BOOTARGS		"console=" __stringify(ACFG_CONSOLE_DEV) "," \
 			__stringify(CONFIG_BAUDRATE) " " MTDPARTS_DEFAULT \
diff --git a/include/configs/calimain.h b/include/configs/calimain.h
index 3b10360..9c2b9e8 100644
--- a/include/configs/calimain.h
+++ b/include/configs/calimain.h
@@ -214,7 +214,6 @@
 #define CONFIG_SETUP_MEMORY_TAGS
 #define CONFIG_BOOTARGS           ""
 #define CONFIG_BOOTCOMMAND        "run checkupdate; run checkbutton;"
-#define CONFIG_ZERO_BOOTDELAY_CHECK   /* check for keypress on bootdelay==0 */
 #define CONFIG_BOOT_RETRY_TIME    60  /* continue boot after 60 s inactivity */
 #define CONFIG_RESET_TO_RETRY
 
diff --git a/include/configs/cm_t35.h b/include/configs/cm_t35.h
index de1999d..695066b 100644
--- a/include/configs/cm_t35.h
+++ b/include/configs/cm_t35.h
@@ -145,7 +145,6 @@
 							/* devices */
 
 /* Environment information */
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_EXTRA_ENV_SETTINGS \
 	"loadaddr=0x82000000\0" \
diff --git a/include/configs/cm_t3517.h b/include/configs/cm_t3517.h
index 87e41bf..78fde3e 100644
--- a/include/configs/cm_t3517.h
+++ b/include/configs/cm_t3517.h
@@ -152,7 +152,6 @@
 							/* devices */
 
 /* Environment information */
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_EXTRA_ENV_SETTINGS \
 	"loadaddr=0x82000000\0" \
diff --git a/include/configs/cm_t43.h b/include/configs/cm_t43.h
index 5076540..9bb975a 100644
--- a/include/configs/cm_t43.h
+++ b/include/configs/cm_t43.h
@@ -98,7 +98,6 @@
 #undef CONFIG_SPL_NAND_SUPPORT
 #undef CONFIG_SYS_MONITOR_LEN
 #undef CONFIG_SYS_MMCSD_RAW_MODE_U_BOOT_SECTOR
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_ENV_SIZE			(16 * 1024)
 #define CONFIG_ENV_VARS_UBOOT_RUNTIME_CONFIG
diff --git a/include/configs/devkit3250.h b/include/configs/devkit3250.h
index 73f53d4..22f4322 100644
--- a/include/configs/devkit3250.h
+++ b/include/configs/devkit3250.h
@@ -178,7 +178,6 @@
  */
 #define CONFIG_CMDLINE_TAG
 #define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_BOOTFILE			"uImage"
 #define CONFIG_BOOTARGS			"console=ttyS0,115200n8"
diff --git a/include/configs/digsy_mtc.h b/include/configs/digsy_mtc.h
index 1145e37..c6d6d41 100644
--- a/include/configs/digsy_mtc.h
+++ b/include/configs/digsy_mtc.h
@@ -379,7 +379,6 @@
 #define CONFIG_CMDLINE_EDITING	1
 
 #define CONFIG_MX_CYCLIC	1
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_SYS_CBSIZE		1024
 #define CONFIG_SYS_PBSIZE (CONFIG_SYS_CBSIZE+sizeof(CONFIG_SYS_PROMPT)+16)
diff --git a/include/configs/dlvision-10g.h b/include/configs/dlvision-10g.h
index 445a346..c5c2f4d 100644
--- a/include/configs/dlvision-10g.h
+++ b/include/configs/dlvision-10g.h
@@ -27,7 +27,6 @@
 
 #define CONFIG_SYS_CLK_FREQ	33333333 /* external frequency to pll   */
 
-#undef CONFIG_ZERO_BOOTDELAY_CHECK     /* ignore keypress on bootdelay==0 */
 
 /*
  * Configure PLL
diff --git a/include/configs/exynos-common.h b/include/configs/exynos-common.h
index 98474d3..ef3d210 100644
--- a/include/configs/exynos-common.h
+++ b/include/configs/exynos-common.h
@@ -51,7 +51,6 @@
 #define CONFIG_EXYNOS_DWMMC
 #define CONFIG_BOUNCE_BUFFER
 
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 /* PWM */
 #define CONFIG_PWM
diff --git a/include/configs/gdppc440etx.h b/include/configs/gdppc440etx.h
index 8d79ea8..2e947fe 100644
--- a/include/configs/gdppc440etx.h
+++ b/include/configs/gdppc440etx.h
@@ -33,7 +33,6 @@
 #define CONFIG_BOARD_EARLY_INIT_F	1	/* call board_early_init_f*/
 #define CONFIG_MISC_INIT_R		1	/* call misc_init_r()     */
 
-#undef CONFIG_ZERO_BOOTDELAY_CHECK     /* ignore keypress on bootdelay==0 */
 
 /*
  * Base addresses -- Note these are effective addresses where the
diff --git a/include/configs/hrcon.h b/include/configs/hrcon.h
index 6a8660b..2368bfe 100644
--- a/include/configs/hrcon.h
+++ b/include/configs/hrcon.h
@@ -543,7 +543,6 @@ void fpga_control_clear(unsigned int bus, int pin);
 #define CONFIG_SYS_LOAD_ADDR		0x2000000 /* default load address */
 #define CONFIG_SYS_HZ		1000	/* decrementer freq: 1ms ticks */
 
-#undef CONFIG_ZERO_BOOTDELAY_CHECK	/* ignore keypress on bootdelay==0 */
 
 #define CONFIG_SYS_CBSIZE	1024 /* Console I/O Buffer Size */
 
diff --git a/include/configs/intip.h b/include/configs/intip.h
index f3db077..1fece9f 100644
--- a/include/configs/intip.h
+++ b/include/configs/intip.h
@@ -48,7 +48,6 @@
 #define CONFIG_BOARD_TYPES		1	/* support board types */
 #define CFG_ALT_MEMTEST
 
-#undef CONFIG_ZERO_BOOTDELAY_CHECK     /* ignore keypress on bootdelay==0 */
 
 /*
  * Base addresses -- Note these are effective addresses where the
diff --git a/include/configs/io.h b/include/configs/io.h
index 0dd7f00..b2a600a 100644
--- a/include/configs/io.h
+++ b/include/configs/io.h
@@ -33,7 +33,6 @@
 #define PLLMR0_DEFAULT PLLMR0_266_133_66
 #define PLLMR1_DEFAULT PLLMR1_266_133_66
 
-#undef CONFIG_ZERO_BOOTDELAY_CHECK	/* ignore keypress on bootdelay==0 */
 
 /* new uImage format support */
 #define CONFIG_FIT_DISABLE_SHA256
diff --git a/include/configs/io64.h b/include/configs/io64.h
index 1a6275e..7bb4f3d 100644
--- a/include/configs/io64.h
+++ b/include/configs/io64.h
@@ -44,7 +44,6 @@
 #define CONFIG_MISC_INIT_R
 #define CONFIG_LAST_STAGE_INIT
 
-#undef CONFIG_ZERO_BOOTDELAY_CHECK	/* ignore keypress on bootdelay==0 */
 
 /*-----------------------------------------------------------------------
  * Base addresses -- Note these are effective addresses where the
diff --git a/include/configs/iocon.h b/include/configs/iocon.h
index 43688c7..5ed6749 100644
--- a/include/configs/iocon.h
+++ b/include/configs/iocon.h
@@ -35,7 +35,6 @@
 #define PLLMR0_DEFAULT PLLMR0_266_133_66
 #define PLLMR1_DEFAULT PLLMR1_266_133_66
 
-#undef CONFIG_ZERO_BOOTDELAY_CHECK	/* ignore keypress on bootdelay==0 */
 
 /* new uImage format support */
 #define CONFIG_FIT_DISABLE_SHA256
diff --git a/include/configs/legoev3.h b/include/configs/legoev3.h
index f52750e..04f593e 100644
--- a/include/configs/legoev3.h
+++ b/include/configs/legoev3.h
@@ -168,7 +168,6 @@
 #define CONFIG_SERIAL_TAG
 #define CONFIG_SETUP_MEMORY_TAGS
 #define CONFIG_SETUP_INITRD_TAG
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 #define CONFIG_BOOTCOMMAND \
 	"if mmc rescan; then " \
 		"if run loadbootscr; then " \
diff --git a/include/configs/meesc.h b/include/configs/meesc.h
index fbcad4a..5e8ba47 100644
--- a/include/configs/meesc.h
+++ b/include/configs/meesc.h
@@ -69,7 +69,6 @@
 #define CONFIG_USART_ID			ATMEL_ID_SYS
 #define CONFIG_BAUDRATE			115200
 
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 /*
  * BOOTP options
diff --git a/include/configs/omap3_logic.h b/include/configs/omap3_logic.h
index 3c11e2a..49a8b3f 100644
--- a/include/configs/omap3_logic.h
+++ b/include/configs/omap3_logic.h
@@ -47,7 +47,6 @@
 #define CONFIG_INITRD_TAG
 #define CONFIG_REVISION_TAG
 #define CONFIG_CMDLINE_EDITING		/* cmd line edit/history */
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check keypress w/no delay */
 
 /* Hardware drivers */
 
diff --git a/include/configs/pcm030.h b/include/configs/pcm030.h
index 80d5d6c..a3fc49a 100644
--- a/include/configs/pcm030.h
+++ b/include/configs/pcm030.h
@@ -70,7 +70,6 @@ Serial console configuration
 /*-----------------------------------------------------------------------------
 Autobooting
 -----------------------------------------------------------------------------*/
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* allow stopping of boot process */
 					/* even with bootdelay=0 */
 #undef	CONFIG_BOOTARGS
 
diff --git a/include/configs/r7780mp.h b/include/configs/r7780mp.h
index c15580c..90bbd2b 100644
--- a/include/configs/r7780mp.h
+++ b/include/configs/r7780mp.h
@@ -32,7 +32,6 @@
 #define CONFIG_ENV_OVERWRITE	1
 
 /* check for keypress on bootdelay==0 */
-/*#define CONFIG_ZERO_BOOTDELAY_CHECK*/
 
 #define CONFIG_SYS_TEXT_BASE		0x0FFC0000
 #define CONFIG_SYS_SDRAM_BASE		(0x08000000)
diff --git a/include/configs/s5p_goni.h b/include/configs/s5p_goni.h
index afea884..a06de29 100644
--- a/include/configs/s5p_goni.h
+++ b/include/configs/s5p_goni.h
@@ -94,7 +94,6 @@
 				",12m(modem)"\
 				",60m(qboot)\0"
 
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 /* partitions definitions */
 #define PARTS_CSA			"csa-mmc"
diff --git a/include/configs/smdk2410.h b/include/configs/smdk2410.h
index f733c35..e328842 100644
--- a/include/configs/smdk2410.h
+++ b/include/configs/smdk2410.h
@@ -82,7 +82,6 @@
 /* autoboot */
 #define CONFIG_BOOT_RETRY_TIME	-1
 #define CONFIG_RESET_TO_RETRY
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_NETMASK		255.255.255.0
 #define CONFIG_IPADDR		10.0.0.110
diff --git a/include/configs/smdkc100.h b/include/configs/smdkc100.h
index fe41d17..b553630 100644
--- a/include/configs/smdkc100.h
+++ b/include/configs/smdkc100.h
@@ -72,7 +72,6 @@
 #define CONFIG_CMD_MTDPARTS
 
 
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_MTD_DEVICE
 #define CONFIG_MTD_PARTITIONS
diff --git a/include/configs/snapper9260.h b/include/configs/snapper9260.h
index 7981a8d..b33bec9 100644
--- a/include/configs/snapper9260.h
+++ b/include/configs/snapper9260.h
@@ -117,7 +117,6 @@
 
 /* Boot options */
 #define CONFIG_SYS_LOAD_ADDR		0x23000000
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_BOOTP_BOOTFILESIZE
 #define CONFIG_BOOTP_BOOTPATH
diff --git a/include/configs/snapper9g45.h b/include/configs/snapper9g45.h
index 8344f15..fd6c70e 100644
--- a/include/configs/snapper9g45.h
+++ b/include/configs/snapper9g45.h
@@ -95,7 +95,6 @@
 
 /* Boot options */
 #define CONFIG_SYS_LOAD_ADDR		0x23000000
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_BOOTP_BOOTFILESIZE
 #define CONFIG_BOOTP_BOOTPATH
diff --git a/include/configs/spear-common.h b/include/configs/spear-common.h
index 43ba84a..7f6cb93 100644
--- a/include/configs/spear-common.h
+++ b/include/configs/spear-common.h
@@ -178,7 +178,6 @@
 #define CONFIG_CMDLINE_TAG
 #define CONFIG_SETUP_MEMORY_TAGS
 #define CONFIG_MISC_INIT_R
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_SYS_MEMTEST_START		0x00800000
 #define CONFIG_SYS_MEMTEST_END			0x04000000
diff --git a/include/configs/strider.h b/include/configs/strider.h
index 36561e0..be8d165 100644
--- a/include/configs/strider.h
+++ b/include/configs/strider.h
@@ -581,7 +581,6 @@ void fpga_control_clear(unsigned int bus, int pin);
 #define CONFIG_SYS_LOAD_ADDR		0x2000000 /* default load address */
 #define CONFIG_SYS_HZ		1000	/* decrementer freq: 1ms ticks */
 
-#undef CONFIG_ZERO_BOOTDELAY_CHECK	/* ignore keypress on bootdelay==0 */
 
 #define CONFIG_SYS_CBSIZE	1024 /* Console I/O Buffer Size */
 
diff --git a/include/configs/theadorable.h b/include/configs/theadorable.h
index dda70c5..1caa858 100644
--- a/include/configs/theadorable.h
+++ b/include/configs/theadorable.h
@@ -64,7 +64,6 @@
 #define PHY_ANEG_TIMEOUT	8000	/* PHY needs a longer aneg time */
 
 #define CONFIG_SYS_CONSOLE_INFO_QUIET	/* don't print console @ startup */
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
 #define CONFIG_SYS_ALT_MEMTEST
 #define CONFIG_PREBOOT
 
diff --git a/include/configs/tricorder.h b/include/configs/tricorder.h
index aed3931..127a968 100644
--- a/include/configs/tricorder.h
+++ b/include/configs/tricorder.h
@@ -46,7 +46,6 @@
 #define CONFIG_DISPLAY_BOARDINFO
 
 #define CONFIG_SILENT_CONSOLE
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 /* Clock Defines */
 #define V_OSCK				26000000 /* Clock output from T2 */
diff --git a/include/configs/uniphier.h b/include/configs/uniphier.h
index 77057d0..47fe2a4 100644
--- a/include/configs/uniphier.h
+++ b/include/configs/uniphier.h
@@ -147,7 +147,6 @@
 #define CONFIG_SYS_MEMTEST_START	CONFIG_SYS_SDRAM_BASE
 #define CONFIG_SYS_MEMTEST_END		(CONFIG_SYS_SDRAM_BASE + 0x01000000)
 
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
 
 /*
  * Network Configuration
diff --git a/include/configs/vinco.h b/include/configs/vinco.h
index 35fe9de..4ae179c 100644
--- a/include/configs/vinco.h
+++ b/include/configs/vinco.h
@@ -150,6 +150,5 @@
 	"bootdelay=0\0"
 
 #endif
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #endif
diff --git a/include/configs/work_92105.h b/include/configs/work_92105.h
index ba222f9..7c99ef6 100644
--- a/include/configs/work_92105.h
+++ b/include/configs/work_92105.h
@@ -174,7 +174,6 @@
 #define CONFIG_SETUP_MEMORY_TAGS
 #define CONFIG_INITRD_TAG
 
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_BOOTFILE			"uImage"
 #define CONFIG_BOOTARGS			"console=ttyS2,115200n8"
diff --git a/include/configs/x600.h b/include/configs/x600.h
index 71c0b45..748e331 100644
--- a/include/configs/x600.h
+++ b/include/configs/x600.h
@@ -145,7 +145,6 @@
 #define CONFIG_MISC_INIT_R
 #define CONFIG_BOARD_LATE_INIT
 #define CONFIG_MX_CYCLIC		/* enable mdc/mwc commands      */
-#define CONFIG_ZERO_BOOTDELAY_CHECK
 
 #define CONFIG_SYS_MEMTEST_START		0x00800000
 #define CONFIG_SYS_MEMTEST_END			0x04000000
diff --git a/include/configs/xilinx-ppc.h b/include/configs/xilinx-ppc.h
index e97e9d0..39c1bd8 100644
--- a/include/configs/xilinx-ppc.h
+++ b/include/configs/xilinx-ppc.h
@@ -57,7 +57,6 @@
 #define CONFIG_CMDLINE_EDITING		/* add command line history     */
 #define CONFIG_AUTO_COMPLETE		/* add autocompletion support   */
 #define CONFIG_MX_CYCLIC		/* enable mdc/mwc commands      */
-#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
 #define CONFIG_VERSION_VARIABLE		/* include version env variable */
 #define CONFIG_SYS_CONSOLE_INFO_QUIET	/* don't print console @ startup */
 #define CONFIG_LOADS_ECHO		/* echo on for serial download  */